<!--
The page on which the user uploads a submission for a competition.

Takes the competition ID as a url param.
-->
<template>
  <div id="submission-creation-view">
    <b-card style="margin: 10px" v-if="this.doneLoading">
      <h6 slot="header" class="mb-0" style="font-weight: bold;">
        Upload Submission: {{ competition.getTitle() }}
      </h6>
      
      <uploads-panel 
          :handler="this.handler"
          :function="'registerFiles'"
          :upload="this.upload"
          v-on:upload-done="uploadDone"/>

      <b-button 
            id="submission_upload_button"
            variant="primary"
            class="upload-btn"
            @click="submitPressed">
        <upload/> Upload
      </b-button>

    </b-card>
  </div>
</template>
<script>
import backend from '@/backend-manager'
import Competition from '@/models/Competition'
import Submission from '@/models/Submission'
import UploadsPanel from '@/components/UploadsPanel'
import Upload from 'vue-material-design-icons/upload.vue'

export default {
    components: {
        UploadsPanel: UploadsPanel,
        Upload: Upload
    },

     created: async function () {
        this.handler = backend.getInstance().getSubmissionCreationManager()
        this.competition = new Competition(this.$route.params.id)
        await this.competition.load()
        this.doneLoading = true
    },

    data: function() {
        return {
            doneLoading: false,
            upload: false,
            submitted: false,

            competition: {},
            handler: {}
        }
    },

    methods: {
        submitPressed: async function() {
            if (this.submitted) {
                return
            }

            var submission = new Submission(null,
                    '', // userID
                    this.competition._id, // Competition id
                    '', // status
                    new Date(), // submitted (date)
                    {}) // results, rank, worstRank score on default
            await this.handler.submit(submission)

            this.submitted = true
            this.upload = true
            console.log('Submission upload started')
        },

        uploadDone: async function () {
            console.log('Submission upload finished')
            await this.handler.finish()
            this.$router.push({name: 'SubmissionBrowser'})
        }
    }    

}
</script>
<style scoped>

</style>
